## swupdate 2020.04

=== Makefile ===
VERSION = 2020
PATCHLEVEL = 04
SUBLEVEL = 0
EXTRAVERSION =
NAME =

# *DOCUMENTATION*
# To see a list of typical targets execute "make help"
# More info can be located in ./README
# Comments in this file are targeted only to the developer, do not
# expect to learn how to build the kernel reading this file.

# Do not:
# o  use make's built-in rules
#    (this increases performance and avoids hard-to-debug behaviour);
# o  print "Entering directory ...";
MAKEFLAGS += -r --no-print-directory

OSNAME := $(shell uname -s)
ifeq ($(OSNAME),Linux)
export HAVE_LINUX = y
else
export HAVE_LINUX = n
endif
ifeq ($(OSNAME),FreeBSD)
export HAVE_FREEBSD = y
else
export HAVE_FREEBSD = n
endif

# To put more focus on warnings, be less verbose as default
# Use 'make V=1' to see the full commands

ifeq ("$(origin V)", "command line")
  KBUILD_VERBOSE = $(V)
endif
ifndef KBUILD_VERBOSE
  KBUILD_VERBOSE = 0
endif

# kbuild supports saving output files in a separate directory.
# To locate output files in a separate directory two syntaxes are supported.
# In both cases the working directory must be the root of the kernel src.
# 1) O=
# Use "make O=dir/to/store/output/files/"
#
# 2) Set KBUILD_OUTPUT
# Set the environment variable KBUILD_OUTPUT to point to the directory
# where the output files shall be placed.
# export KBUILD_OUTPUT=dir/to/store/output/files/
# make
#
# The O= assignment takes precedence over the KBUILD_OUTPUT environment
# variable.

# Our default target
PHONY := _all
_all:

# KBUILD_SRC is set on invocation of make in OBJ directory
# KBUILD_SRC is not intended to be used by the regular user (for now)
ifeq ($(KBUILD_SRC),)

# OK, Make called in directory where kernel src resides
# Do we want to locate output files in a separate directory?
ifeq ("$(origin O)", "command line")
  KBUILD_OUTPUT := $(O)
endif

ifeq ("$(origin W)", "command line")
  export KBUILD_ENABLE_EXTRA_GCC_CHECKS := $(W)
endif

# Cancel implicit rules on top Makefile
$(CURDIR)/Makefile Makefile: ;

ifneq ($(KBUILD_OUTPUT),)
# Invoke a second make in the output directory, passing relevant variables
# check that the output directory actually exists
saved-output := $(KBUILD_OUTPUT)
KBUILD_OUTPUT := $(shell cd $(KBUILD_OUTPUT) && /bin/pwd)
$(if $(KBUILD_OUTPUT),, \
     $(error output directory "$(saved-output)" does not exist))

PHONY += $(MAKECMDGOALS) sub-make

$(filter-out _all sub-make $(CURDIR)/Makefile, $(MAKECMDGOALS)) _all: sub-make
	$(Q)@:

sub-make: FORCE
	$(if $(KBUILD_VERBOSE:1=),@)$(MAKE) -C $(KBUILD_OUTPUT) \
	KBUILD_SRC=$(CURDIR) \
	-f $(CURDIR)/Makefile \
	$(filter-out _all sub-make,$(MAKECMDGOALS))

# Leave processing to above invocation of make
skip-makefile := 1
endif # ifneq ($(KBUILD_OUTPUT),)
endif # ifeq ($(KBUILD_SRC),)

# We process the rest of the Makefile if this is the final invocation of make
ifeq ($(skip-makefile),)

# If building an external module we do not care about the all: rule
# but instead _all depend on modules
PHONY += all
_all: all

srctree		:= $(if $(KBUILD_SRC),$(KBUILD_SRC),$(CURDIR))
objtree		:= $(CURDIR)
src		:= $(srctree)
obj		:= $(objtree)

VPATH		:= $(srctree)

export srctree objtree VPATH

CROSS_COMPILE	?= $(CONFIG_CROSS_COMPILE:"%"=%)

KCONFIG_CONFIG	?= .config
export KCONFIG_CONFIG

# SHELL used by kbuild
CONFIG_SHELL := $(shell if [ -x "$$BASH" ]; then echo $$BASH; \
	  else if [ -x /bin/bash ]; then echo /bin/bash; \
	  else echo sh; fi ; fi)

HOSTCC       = cc
HOSTCXX      = c++
HOSTCFLAGS   = -Wall -Wmissing-prototypes -Wstrict-prototypes -O2 -fomit-frame-pointer
HOSTCXXFLAGS = -O2

# Beautify output
# ---------------------------------------------------------------------------
#
# Normally, we echo the whole command before executing it. By making
# that echo $($(quiet)$(cmd)), we now have the possibility to set
# $(quiet) to choose other forms of output instead, e.g.
#
#         quiet_cmd_cc_o_c = Compiling $(RELDIR)/$@
#         cmd_cc_o_c       = $(CC) $(c_flags) -c -o $@ $<
#
# If $(quiet) is empty, the whole command will be printed.
# If it is set to "quiet_", only the short version will be printed.
# If it is set to "silent_", nothing will be printed at all, since
# the variable $(silent_cmd_cc_o_c) doesn't exist.
#
# A simple variant is to prefix commands with $(Q) - that's useful
# for commands that shall be hidden in non-verbose mode.
#
#	$(Q)ln $@ :<
#
# If KBUILD_VERBOSE equals 0 then the above command will be hidden.
# If KBUILD_VERBOSE equals 1 then the above command is displayed.

ifeq ($(KBUILD_VERBOSE),1)
  quiet =
  Q =
else
  quiet=quiet_
  Q = @
endif

# If the user is running make -s (silent mode), suppress echoing of
# commands

ifneq ($(findstring s,$(MAKEFLAGS)),)
  quiet=silent_
endif

export quiet Q KBUILD_VERBOSE


# Look for make include files relative to root of kernel src
MAKEFLAGS += --include-dir=$(srctree)

# We need some generic definitions (do not try to remake the file).
$(srctree)/scripts/Kbuild.include: ;
include $(srctree)/scripts/Kbuild.include

# Make variables (CC, etc...)

# this looks a bit horrible, but 'VAR ?= VALUE' preserves builtin values
# rather than only user-supplied values from env or command-line
$(call set_if_default_or_unset,AS,$$(CROSS_COMPILE)as)
$(call set_if_default_or_unset,LD,$$(CROSS_COMPILE)cc)
$(call set_if_default_or_unset,CC,$$(CROSS_COMPILE)cc)
$(call set_if_default_or_unset,CPP,$$(CC) -E)
$(call set_if_default_or_unset,AR,$$(CROSS_COMPILE)ar)
$(call set_if_default_or_unset,NM,$$(CROSS_COMPILE)nm)
$(call set_if_default_or_unset,STRIP,$$(CROSS_COMPILE)strip)
$(call set_if_default_or_unset,OBJCOPY,$$(CROSS_COMPILE)objcopy)
$(call set_if_default_or_unset,OBJDUMP,$$(CROSS_COMPILE)objdump)
$(call set_if_default_or_unset,PKG_CONFIG,pkg-config)

AWK		= awk
INSTALLKERNEL  := installkernel
PERL		= perl

CHECKFLAGS     := -D__linux__ -Dlinux -D__STDC__ -Dunix -D__unix__ \
		  -Wbitwise -Wno-return-void $(CF)
CFLAGS_KERNEL	=
AFLAGS_KERNEL	=

BINDIR ?= /usr/bin
LIBDIR ?= /usr/lib
INCLUDEDIR ?= /usr/include

# Use LINUXINCLUDE when you must reference the include/ directory.
# Needed to be compatible with the O= option
LINUXINCLUDE    := -Iinclude \
                   $(if $(KBUILD_SRC), -I$(srctree)/include) \
                   -include include/generated/autoconf.h

KBUILD_CPPFLAGS :=
KBUILD_CFLAGS   :=
KBUILD_AFLAGS_KERNEL :=
KBUILD_CFLAGS_KERNEL :=
KBUILD_AFLAGS   := -D__ASSEMBLY__

# Read KERNELRELEASE from include/config/kernel.release (if it exists)
KERNELRELEASE = $(shell cat include/config/kernel.release 2> /dev/null)
KERNELVERSION = $(VERSION)$(if $(PATCHLEVEL),.$(PATCHLEVEL)$(if $(SUBLEVEL),.$(SUBLEVEL)))$(EXTRAVERSION)

export ARCH SRCARCH CONFIG_SHELL HOSTCC HOSTCFLAGS CROSS_COMPILE AS LD CC
export CPP AR NM STRIP OBJCOPY OBJDUMP
export MAKE AWK GENKSYMS INSTALLKERNEL PERL UTS_MACHINE
export HOSTCXX HOSTCXXFLAGS

export KBUILD_CPPFLAGS NOSTDINC_FLAGS LINUXINCLUDE OBJCOPYFLAGS LDFLAGS
export KBUILD_CFLAGS CFLAGS_KERNEL
export KBUILD_AFLAGS AFLAGS_KERNEL
export KBUILD_AFLAGS_KERNEL KBUILD_CFLAGS_KERNEL
export KBUILD_ARFLAGS

# Files to ignore in find ... statements

RCS_FIND_IGNORE := \( -name SCCS -o -name BitKeeper -o -name .svn -o -name CVS -o -name .pc -o -name .hg -o -name .git \) -prune -o

# ===========================================================================
# Rules shared between *config targets and build targets

-include $(srctree)/Makefile.deps

# Basic helpers built in scripts/
PHONY += scripts_basic
scripts_basic:
	$(Q)$(MAKE) $(build)=scripts/basic

# To avoid any implicit rule to kick in, define an empty command.
scripts/basic/%: scripts_basic ;

PHONY += outputmakefile
# outputmakefile generates a Makefile in the output directory, if using a
# separate output directory. This allows convenient use of make in the
# output directory.
outputmakefile:
ifneq ($(KBUILD_SRC),)
	$(Q)ln -fsn $(srctree) source
	$(Q)$(CONFIG_SHELL) $(srctree)/scripts/mkmakefile \
	    $(srctree) $(objtree) $(VERSION) $(PATCHLEVEL)
endif


# To make sure we do not include .config for any of the *config targets
# catch them early, and hand them over to scripts/kconfig/Makefile
# It is allowed to specify more targets when calling make, including
# mixing *config targets and build targets.
# For example 'make oldconfig all'.
# Detect when mixed targets is specified, and make a second invocation
# of make so .config is not included in this case either (for *config).

no-dot-config-targets := clean mrproper distclean \
			 cscope gtags TAGS tags help %docs check% coccicheck \
			 include/linux/version.h headers_% \
			 kernelversion %src-pkg

config-targets := 0
mixed-targets  := 0
dot-config     := 1

ifneq ($(filter $(no-dot-config-targets), $(MAKECMDGOALS)),)
	ifeq ($(filter-out $(no-dot-config-targets), $(MAKECMDGOALS)),)
		dot-config := 0
	endif
endif

ifneq ($(filter config %config,$(MAKECMDGOALS)),)
        config-targets := 1
        ifneq ($(filter-out config %config,$(MAKECMDGOALS)),)
                mixed-targets := 1
        endif
endif

ifeq ($(mixed-targets),1)
# ===========================================================================
# We're called with mixed targets (*config and build targets).
# Handle them one by one.

%:: FORCE
	$(Q)$(MAKE) -C $(srctree) KBUILD_SRC= $@

else
ifeq ($(config-targets),1)
# ===========================================================================
# *config targets only - make sure prerequisites are updated, and descend
# in scripts/kconfig to make the *config target

# Read arch specific Makefile to set KBUILD_DEFCONFIG as needed.
# KBUILD_DEFCONFIG may point out an alternative default configuration
# used for 'make defconfig'
#include $(srctree)/arch/$(SRCARCH)/Makefile
export KBUILD_DEFCONFIG KBUILD_KCONFIG

config: scripts_basic outputmakefile FORCE
	$(Q)mkdir -p include/linux include/config
	$(Q)$(MAKE) $(build)=scripts/kconfig $@

%config: scripts_basic outputmakefile FORCE
	$(Q)mkdir -p include/linux include/config
	$(Q)$(MAKE) $(build)=scripts/kconfig $@

else


ifeq ($(dot-config),1)
# Read in config
-include include/config/auto.conf


# Read in dependencies to all Kconfig* files, make sure to run
# oldconfig if changes are detected.
-include include/config/auto.conf.cmd

# To avoid any implicit rule to kick in, define an empty command
$(KCONFIG_CONFIG) include/config/auto.conf.cmd: ;

# If .config is newer than include/config/auto.conf, someone tinkered
# with it and forgot to run make oldconfig.
# if auto.conf.cmd is missing then we are probably in a cleaned tree so
# we execute the config step to be sure to catch updated Kconfig files
include/config/%.conf: $(KCONFIG_CONFIG) include/config/auto.conf.cmd
	$(Q)$(MAKE) -f $(srctree)/Makefile silentoldconfig


else
# Dummy target needed, because used as prerequisite
include/config/auto.conf: ;
endif # $(dot-config)

# Now we can define CFLAGS etc according to .config
include $(srctree)/Makefile.flags

# The all: target is the default when no target is given on the
# command line.
# This allow a user to issue only 'make' to build a kernel including modules
# Defaults to vmlinux, but the arch makefile usually adds further targets

objs-y		:= core handlers
libs-y		:= corelib ipc mongoose parser suricatta bootloader
shareds-y	:= bindings
tools-y		:= tools

swupdate-dirs	:= $(objs-y) $(libs-y)
swupdate-objs	:= $(patsubst %,%/built-in.o, $(objs-y))
swupdate-libs	:= $(patsubst %,%/lib.a, $(libs-y))
swupdate-all	:= $(swupdate-objs) $(swupdate-libs)

tools-dirs	:= $(tools-y)
tools-objs	:= $(patsubst %,%/built-in.o, $(tools-y))
tools-bins	:= $(patsubst $(srctree)/$(tools-y)/%.c,$(tools-y)/%,$(wildcard $(srctree)/$(tools-y)/*.c))
tools-bins-unstr:= $(patsubst %,%_unstripped,$(tools-bins))
tools-all	:= $(tools-objs)

ifeq ($(HAVE_LUA),y)
lua_swupdate	:= lua_swupdate.so.0.1
endif

shared-dirs	:= $(shareds-y)
shared-libs	:= $(patsubst %,%/built-in.o, $(shareds-y))
shared-all	:= $(shared-libs)

PHONY += cfg-sanity-check
cfg-sanity-check:

=== core/Makefile ===
# Makefile for swupdate
#
# Copyright (C) 2013 Stefano Babic <sbabic@denx.de>
#
# Based on busybox build system:
#
# Copyright (C) 1999-2005 by Erik Andersen <andersen@codepoet.org>
#
# SPDX-License-Identifier:     GPL-2.0-or-later

obj-y += swupdate.o \
	 cpio_utils.o \
	 notifier.o \
	 handler.o \
	 util.o \
	 parser.o \
	 pctl.o \
	 state.o \
	 syslog.o \
	 installer.o \
	 network_thread.o \
	 stream_interface.o \
	 progress_thread.o \
	 parsing_library.o \
	 artifacts_versions.o \
	 swupdate_dict.o

=== corelib/Makefile ===
# Copyright (C) 2014-2018 Stefano Babic <sbabic@denx.de>
#
# SPDX-License-Identifier:     GPL-2.0-or-later

lib-$(CONFIG_DOWNLOAD)		+= downloader.o
lib-$(CONFIG_MTD)		+= mtd-interface.o
lib-$(CONFIG_LUA)		+= lua_interface.o lua_compat.o
ifeq ($(CONFIG_SSL_IMPL_OPENSSL),y)
lib-$(CONFIG_HASH_VERIFY)	+= verify_signature.o
lib-$(CONFIG_ENCRYPTED_IMAGES)	+= swupdate_decrypt.o
lib-$(CONFIG_SIGALG_RAWRSA)	+= swupdate_rsa_verify.o
lib-$(CONFIG_SIGALG_RSAPSS)	+= swupdate_rsa_verify.o
lib-$(CONFIG_SIGALG_CMS)	+= swupdate_cms_verify.o
endif
ifeq ($(CONFIG_SSL_IMPL_MBEDTLS),y)
lib-$(CONFIG_HASH_VERIFY)	+= verify_signature_mbedtls.o
lib-$(CONFIG_ENCRYPTED_IMAGES)	+= swupdate_decrypt_mbedtls.o
lib-$(CONFIG_SIGALG_RAWRSA)	+= swupdate_rsa_verify_mbedtls.o
lib-$(CONFIG_SIGALG_RSAPSS)	+= swupdate_rsa_verify_mbedtls.o
endif
lib-$(CONFIG_LIBCONFIG)		+= swupdate_settings.o \
				   parsing_library_libconfig.o
lib-$(CONFIG_JSON)		+= parsing_library_libjson.o
lib-$(CONFIG_CHANNEL_CURL)	+= channel_curl.o

=== handlers/Makefile ===
# Copyright (C) 2014-2018 Stefano Babic <sbabic@denx.de>
#
# SPDX-License-Identifier:     GPL-2.0-or-later
#
# Note: the handlers are inserted automatically
# via a GCC constructor. To work, the linker should
# not drop the handler if it is not called.
# Handler can be called dynamically based
# on the received image type.
obj-y	+= dummy_handler.o
obj-$(CONFIG_ARCHIVE) += archive_handler.o
obj-$(CONFIG_BOOTLOADERHANDLER) += boot_handler.o
obj-$(CONFIG_CFI)	+= flash_handler.o
obj-$(CONFIG_DISKPART)	+= diskpart_handler.o
obj-$(CONFIG_CFIHAMMING1)+= flash_hamming1_handler.o
obj-$(CONFIG_LUASCRIPTHANDLER) += lua_scripthandler.o
obj-$(CONFIG_RAW)	+= raw_handler.o
obj-$(CONFIG_RDIFFHANDLER) += rdiff_handler.o
obj-$(CONFIG_READBACKHANDLER) += readback_handler.o
obj-$(CONFIG_REMOTE_HANDLER) += remote_handler.o
obj-$(CONFIG_SHELLSCRIPTHANDLER) += shell_scripthandler.o
obj-$(CONFIG_SSBLSWITCH) += ssbl_handler.o
obj-$(CONFIG_SWUFORWARDER_HANDLER) += swuforward_handler.o swuforward-ws.o
obj-$(CONFIG_UBIVOL)	+= ubivol_handler.o
obj-$(CONFIG_UCFWHANDLER)	+= ucfw_handler.o

=== ipc/Makefile ===
# Copyright (C) 2014-2018 Stefano Babic <sbabic@denx.de>
#
# SPDX-License-Identifier:     GPL-2.0-or-later
lib-y			+= network_ipc.o network_ipc-if.o progress_ipc.o

EXTRA_CFLAGS += -fPIC

=== mongoose/Makefile ===
ifneq ($(CONFIG_WEBSERVER),)
ifneq ($(CONFIG_MONGOOSE),)
KBUILD_CFLAGS += -DMG_ENABLE_HTTP_STREAMING_MULTIPART=1
KBUILD_CFLAGS += -DMG_ENABLE_HTTP_WEBSOCKET=1 -DMG_ENABLE_THREADS=1
ifneq ($(CONFIG_MONGOOSEIPV6),)
KBUILD_CFLAGS += -DMG_ENABLE_IPV6=1
endif
ifneq ($(CONFIG_MONGOOSESSL),)
KBUILD_CFLAGS += -DMG_ENABLE_SSL=1
ifeq ($(CONFIG_SSL_IMPL_OPENSSL),y)
KBUILD_CFLAGS += -DMG_SSL_IF=MG_SSL_IF_OPENSSL
endif
ifeq ($(CONFIG_SSL_IMPL_MBEDTLS),y)
KBUILD_CFLAGS += -DMG_SSL_IF=MG_SSL_IF_MBEDTLS
endif
endif
endif
endif

lib-$(CONFIG_MONGOOSE)	+= mongoose.o \
			   mongoose_interface.o

=== test/Makefile ===
## Author: Christian Storm
## Copyright (C) 2017, Siemens AG
##
## This program is free software; you can redistribute it and/or
## modify it under the terms of the GNU General Public License as
## published by the Free Software Foundation; either version 2 of
## the License, or (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc.

tests-$(CONFIG_ENCRYPTED_IMAGES) += test_crypt
tests-$(CONFIG_HASH_VERIFY) += test_hash
ifeq ($(CONFIG_SIGALG_RAWRSA),y)
tests-$(CONFIG_SIGNED_IMAGES) += test_verify
endif
tests-$(CONFIG_SURICATTA_HAWKBIT) += test_json
tests-$(CONFIG_SURICATTA_HAWKBIT) += test_server_hawkbit

ccflags-y += -I$(src)/../

TARGETS    = $(addprefix $(obj)/, $(tests-y))
tests-objs = $(addsuffix .o,   $(TARGETS))
tests-lnk  = $(addsuffix .lnk, $(TARGETS))
targets   += $(addsuffix .o,   $(tests-y))

ifneq ($(CONFIG_EXTRA_LDFLAGS),)
EXTRA_LDFLAGS += $(strip $(subst ",,$(CONFIG_EXTRA_LDFLAGS)))#"))
endif

## transfer __mock_*() functions to according linker flags via rudimentary regex awk parsing
LDMOCKS = `/usr/bin/gawk '/^[^(extern)|(static)]*([\*_[:alnum:]]+[[:blank:]]+)+[\*]*__wrap_/{where = match($$0,"__wrap_[_[:alnum:]]+"); if (RSTART > 0) { print "-Wl,--wrap=" substr($$0, RSTART+7, RLENGTH-7);}}' $(basename $@).c`

quiet_cmd_linktestexe = LD      $(basename $@)
      cmd_linktestexe = $(srctree)/scripts/trylink \
						"$(basename $@)" \
						"$(CC)" \
						"$(KBUILD_CFLAGS)" \
						"$(LDFLAGS) $(EXTRA_LDFLAGS) $(LDMOCKS)" \
						"$(basename $@).o $(subst core/built-in.o,core/built-in.o.tmp,$(SWOBJS))" \
						"$(SWLIBS)" \
						"$(LDLIBS) cmocka"

EXECUTE_TEST = echo "RUN $(subst $(obj)/,,$(var))"; CMOCKA_MESSAGE_OUTPUT=TAP $(var)

PHONY += default
default:
	$(info please run 'make test' in swupdate main directory)

PHONY += tests
ifneq "$(tests-y)" ""
tests: $(tests-objs) $(tests-lnk)
	@+$(foreach var,$(TARGETS),$(EXECUTE_TEST);)
else
tests:
	@$(info nothing to test.)
	@:
endif

$(obj)/%.lnk: $(obj)/%.o $(objtree)/core/built-in.o
	$(Q)strip -N main -o $(objtree)/core/built-in.o.tmp $(objtree)/core/built-in.o
	$(Q)$(call cmd,linktestexe)

DATADIR := test/data

$(obj)/test_verify.o: $(DATADIR)/signature $(DATADIR)/signing-pubkey.pem

.INTERMEDIATE: $(DATADIR)/signature
$(DATADIR)/signature: $(DATADIR)/to-be-signed $(DATADIR)/signing-secret.pem
	$(if $(Q),@echo "  SIGN    $@")
	$(Q)openssl dgst -sha256 -sign $(DATADIR)/signing-secret.pem $(DATADIR)/to-be-signed > $@

.INTERMEDIATE: $(DATADIR)/signing-pubkey.pem
$(DATADIR)/signing-pubkey.pem: $(DATADIR)/signing-secret.pem
	$(if $(Q),@echo "  EXPORT  $@")
	$(Q)openssl rsa -in $< -out $@ -outform PEM -pubout 2>/dev/null

.INTERMEDIATE: $(DATADIR)/signing-secret.pem
$(DATADIR)/signing-secret.pem:
	$(if $(Q),@echo "  GEN     $@")
	$(Q)openssl genrsa -out $@ 2>/dev/null

.PHONY: $(PHONY)

=== debian/changelog ===
swupdate (2020.04-2) unstable; urgency=low

  [ Debian Janitor ]
  * Use secure URI in Homepage field.
  * Remove obsolete field Name from debian/upstream/metadata (already present in
    machine-readable debian/copyright).

  [ Bastian Germann ]
  * Don't run unit tests on mips platforms
  * lintian: source-is-missing (line length)
  * Add MTD/UBI support (Closes: #967850)
  * dh: Rename .tmpfile to .tmpfiles
  * Introduce a pkg.swupdate.uboot profile
  * Don't autostart swupdate-usb
  * d/copyright: Match test_crypt.c only once

  [Nobuhiro Iwamatsu]
  * Add d/source/lintian-overrides.
    - Override source: source-is-missing debian/missing-sources/dropzone.js

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Thu, 22 Oct 2020 09:02:05 +0900

swupdate (2020.04-1) unstable; urgency=medium

  [ Nobuhiro Iwamatsu ]
  * Add d/missing-sources

  [ SZ Lin (林上智) ]
  * Bump Standards-Version to 4.5.0
  * Bump debhelper-compat to 13
  * Add configuration setting of Salsa CI
  * Add a dependency package for CI testing
  * Fix autopkgtest error

  [ Bastian Germann ]
  * Fix nodoc usage (Closes: #950772)
  * Introduce lua package and nolua profile
  * Remove file filter
  * defconfig: Activate CONFIG_SIGALG_CMS
  * defconfig: Set Debian's default grubenv path
  * defconfig: Save suricatta state in grubenv
  * defconfig: Enable rdiff handler
  * defconfig: Enable zstd compression
  * Update signing key for version 2020.04
  * Remove upstream patches
  * lintian: debian-rules-uses-as-needed-linker-flag
  * d/copyright: suricatta test files were moved
  * Add new handlers
  * Enable cross compilation
  * Add a backports profile
  * New upstream version 2020.04 (Closes: #948673)

 -- SZ Lin (林上智) <szlin@debian.org>  Sun, 05 Jul 2020 20:01:25 +0800

swupdate (2019.04+git20190903.c3ef374-1~exp1) experimental; urgency=medium

  * Snapshot, taken from the master (20190903). (Closes: #907041)
    - Change license for Logo.
  * Update d/copytight
    - Add license information of SWUpdate.svg.
  * Update d/control.
    - Add libwebsockets-dev, liburiparser-dev and libcmocka-dev to B-D.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Tue, 29 Oct 2019 23:46:31 +0900

swupdate (2019.04-1~exp1) UNRELEASED; urgency=medium

  * New upstream release.
  * Add d/source/lintian-overrides
  * Update d/swupdate.install
    - Fix filename to install.
    - Use dh-exec.
  * Update d/control
    - Add dh-exec to B-D
  * Add d/configs.
    - Add config for debian. This config file removed MTD.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Tue, 06 Aug 2019 22:54:13 +0900

swupdate (2019.04~rc1+git20190320.bad559b+dfsg-1~exp1) UNRELEASED; urgency=medium

  [ Stefano Babic ]
  * Initial release

  [ SZ Lin (林上智) ]
  * Fix copyright issues
  * Tidy Debian packaging files

 -- SZ Lin (林上智) <szlin@debian.org>  Sun, 21 Apr 2019 18:34:58 +0800

=== debian/control ===
Source: swupdate
Section: embedded
Priority: optional
Maintainer: Stefano Babic <sbabic@denx.de>
Uploaders: SZ Lin (林上智) <szlin@debian.org>,
           Nobuhiro Iwamatsu <iwamatsu@debian.org>
Build-Depends: debhelper-compat (= 13),
               dh-exec,
               dh-lua <!nolua>,
               liblua5.2-dev <!nolua>,
               libfdisk-dev,
               latexmk <!nodoc>,
               libconfig-dev,
               libcurl4-openssl-dev,
               libarchive-dev,
               libjson-c-dev,
               librsync-dev,
               libssl-dev,
               libsystemd-dev,
               libzmq3-dev,
               zlib1g-dev,
               libzstd-dev,
               libmtd-dev <!pkg.swupdate.bpo>,
               libubi-dev <!pkg.swupdate.bpo>,
               libwebsockets-dev (>= 3.2.0) <!pkg.swupdate.bpo>,
               liburiparser-dev <!pkg.swupdate.bpo>,
               libubootenv-dev <pkg.swupdate.uboot>,
               libcmocka-dev,
               pkg-config,
               gawk,
               python3-sphinx <!nodoc>,
               texlive-latex-recommended <!nodoc>,
               texlive-fonts-recommended <!nodoc>,
               texlive-formats-extra <!nodoc>
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://sbabic.github.io/swupdate
Vcs-Browser: https://salsa.debian.org/debian/swupdate
Vcs-Git: https://salsa.debian.org/debian/swupdate.git

Package: swupdate
Architecture: linux-any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Built-Using: ${Built-Using}
Description: Software update framework for embedded systems
 swupdate is a Linux update agent with the goal to provide an efficient and
 safe way to update an embedded system.
 .
  - Install on embedded media (eMMC, SD, Raw NAND, NOR and SPI-NOR flashes)
  - Allow delivery single image for multiple devices
  - Multiple interfaces for getting software
    1. local storage
    2. integrated web server
    3. integrated REST client connector to hawkBit
    4. remote server download
  - Software delivered as images, gzipped tarball, etc
  - Allow custom handlers for installing FPGA/ microcontroller firmware.
  - Power-Off safe

Package: swupdate-dev
Section: libdevel
Architecture: linux-any
Depends: ${misc:Depends}
Suggests: swupdate-doc
Description: Development files for swupdate framework
 This package contains the development files for swupdate.
 .
 swupdate is a Linux update agent with the goal to provide an efficient and
 safe way to update an embedded system.
 .
  - Install on embedded media (eMMC, SD, Raw NAND, NOR and SPI-NOR flashes)
  - Allow delivery single image for multiple devices
  - Multiple interfaces for getting software
    1. local storage
    2. integrated web server
    3. integrated REST client connector to hawkBit
    4. remote server download
  - Software delivered as images, gzipped tarball, etc
  - Allow custom handlers for installing FPGA/ microcontroller firmware.
  - Power-Off safe

Package: swupdate-doc
Section: doc
Architecture: all
Build-Profiles: <!nodoc>
Depends: ${misc:Depends}
Description: Documentation for swupdate framework
 This package contains the documentation for swupdate.
 .
 swupdate is a Linux update agent with the goal to provide an efficient and
 safe way to update an embedded system.
 .
  - Install on embedded media (eMMC, SD, Raw NAND, NOR and SPI-NOR flashes)
  - Allow delivery single image for multiple devices
  - Multiple interfaces for getting software
    1. local storage
    2. integrated web server
    3. integrated REST client connector to hawkBit
    4. remote server download
  - Software delivered as images, gzipped tarball, etc
  - Allow custom handlers for installing FPGA/ microcontroller firmware.
  - Power-Off safe

Package: lua-swupdate
Section: interpreters
Architecture: linux-any
Build-Profiles: <!nolua>
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: swupdate bindings for the Lua language
 This package contains the Lua bindings for swupdate.
 .
 swupdate is a Linux update agent with the goal to provide an efficient and
 safe way to update an embedded system.
 .
  - Install on embedded media (eMMC, SD, Raw NAND, NOR and SPI-NOR flashes)
  - Allow delivery single image for multiple devices
  - Multiple interfaces for getting software
    1. local storage
    2. integrated web server
    3. integrated REST client connector to hawkBit
    4. remote server download
  - Software delivered as images, gzipped tarball, etc
  - Allow custom handlers for installing FPGA/ microcontroller firmware.
  - Power-Off safe

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export HAVE_LUA=n
ifeq (,$(filter nolua,$(DEB_BUILD_PROFILES)))
export LUA_VERSION=5.2
export LUA_MODNAME=lua_swupdate
export PKG_NAME=swupdate
export DH_WITH=--with lua
export HAVE_LUA=y
endif
ifneq (,$(findstring mips,$(DEB_HOST_ARCH)))
export DEB_BUILD_MAINT_OPTIONS:=$(DEB_BUILD_MAINT_OPTIONS) nocheck
endif

override_dh_auto_configure:
	cp debian/configs/defconfig  configs/debian_defconfig
ifeq (,$(filter pkg.swupdate.bpo,$(DEB_BUILD_PROFILES)))
	echo CONFIG_SWUFORWARDER_HANDLER=y >> configs/debian_defconfig
	echo CONFIG_CFI=y                  >> configs/debian_defconfig
	echo CONFIG_CFIHAMMING1=y          >> configs/debian_defconfig
	echo CONFIG_UBIVOL=y               >> configs/debian_defconfig
	echo CONFIG_SSBLSWITCH=y           >> configs/debian_defconfig
else
	echo "# CONFIG_MTD is not set"     >> configs/debian_defconfig
endif
ifeq (,$(filter pkg.swupdate.uboot,$(DEB_BUILD_PROFILES)))
	echo CONFIG_BOOTLOADER_GRUB=y                   >> configs/debian_defconfig
	echo CONFIG_GRUBENV_PATH=\"/boot/grub/grubenv\" >> configs/debian_defconfig
else
	echo CONFIG_UBOOT=y                             >> configs/debian_defconfig
endif
ifneq (,$(LUA_VERSION))
	echo CONFIG_LUAPKG=\"lua$(LUA_VERSION)\" >> configs/debian_defconfig
	echo CONFIG_LUASCRIPTHANDLER=y           >> configs/debian_defconfig
	echo CONFIG_HANDLER_IN_LUA=y             >> configs/debian_defconfig
endif
	echo CONFIG_EXTRA_CFLAGS=\"$(CFLAGS) $(CPPFLAGS)\" >> configs/debian_defconfig
	echo CONFIG_EXTRA_LDFLAGS=\"$(LDFLAGS)\"           >> configs/debian_defconfig
	echo CONFIG_EXTRA_LDLIBS=\"$(LDLIBS)\"             >> configs/debian_defconfig
	$(MAKE) debian_defconfig

override_dh_auto_build:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
	$(MAKE) man latexpdf
	mv doc/build/man/client.1 doc/build/man/swupdate-client.1
	mv doc/build/man/sendtohawkbit.1 doc/build/man/swupdate-sendtohawkbit.1
	mv doc/build/man/hawkbitcfg.1 doc/build/man/swupdate-hawkbitcfg.1
	mv doc/build/man/progress.1 doc/build/man/swupdate-progress.1
	mv doc/build/man/sysrestart.1 doc/build/man/swupdate-sysrestart.1
endif
	dh_auto_build -- V=1

override_dh_auto_test:
	dh_auto_test -- V=1

override_dh_auto_install:
	dh_auto_install -- V=1

override_dh_installsystemd:
	dh_installsystemd --no-start
	dh_installsystemd --name=swupdate-progress
	dh_installsystemd --no-start --name=swupdate-usb@

ifeq (,$(filter pkg.swupdate.bpo,$(DEB_BUILD_PROFILES)))
override_dh_gencontrol:
	dh_gencontrol -- -VBuilt-Using="$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W libmtd-dev libubi-dev)"
endif

override_dh_dwz:
	dh_dwz --no-dwz-multifile

override_dh_missing:
	dh_missing --fail-missing

ifneq (,$(filter nocheck,$(DEB_BUILD_PROFILES)))
override_dh_auto_test:
endif

%:
	dh $@ $(DH_WITH)

## swupdate 2020.11

=== Makefile ===
--- 
+++ 
@@ -1,8 +1,10 @@
 VERSION = 2020
-PATCHLEVEL = 04
+PATCHLEVEL = 11
 SUBLEVEL = 0
 EXTRAVERSION =
 NAME =
+
+IPCLIB_VERSION = 0.1
 
 # *DOCUMENTATION*
 # To see a list of typical targets execute "make help"
@@ -357,9 +359,15 @@
 # Defaults to vmlinux, but the arch makefile usually adds further targets
 
 objs-y		:= core handlers
-libs-y		:= corelib ipc mongoose parser suricatta bootloader
-shareds-y	:= bindings
+libs-y		:= corelib mongoose parser suricatta bootloader
+bindings-y	:= bindings
 tools-y		:= tools
+
+ipc-y		:= ipc
+ipc-lib 	:= $(patsubst %,%/built-in.o, $(ipc-y))
+ipc-dirs 	:= $(ipc-y)
+
+swupdate-ipc-lib 	:= libswupdate.so.${IPCLIB_VERSION}
 
 swupdate-dirs	:= $(objs-y) $(libs-y)
 swupdate-objs	:= $(patsubst %,%/built-in.o, $(objs-y))
@@ -376,9 +384,4 @@
 lua_swupdate	:= lua_swupdate.so.0.1
 endif
 
-shared-dirs	:= $(shareds-y)
-shared-libs	:= $(patsubst %,%/built-in.o, $(shareds-y))
-shared-all	:= $(shared-libs)
-
-PHONY += cfg-sanity-check
-cfg-sanity-check:
+bindings-dirs	:= $(bindings-y)

=== bindings/Makefile ===
# Copyright (C) 2014-2018 Stefano Babic <sbabic@denx.de>
#
# SPDX-License-Identifier:     GPL-2.0-or-later
obj-$(CONFIG_LUA)	+= auxiliar.o lua_swupdate.o lua_compat_shared.o

EXTRA_CFLAGS += -fPIC

=== bootloader/Makefile ===
# Copyright (C) 2014-2018 Stefano Babic <sbabic@denx.de>
#
# SPDX-License-Identifier:     GPL-2.0-or-later
#
lib-$(CONFIG_UBOOT)		+= uboot.o
lib-$(CONFIG_BOOTLOADER_NONE)	+= none.o
lib-$(CONFIG_BOOTLOADER_GRUB)	+= grub.o
lib-$(CONFIG_BOOTLOADER_EBG)		+= ebg.o

=== core/Makefile ===
--- 
+++ 
@@ -23,4 +23,5 @@
 	 progress_thread.o \
 	 parsing_library.o \
 	 artifacts_versions.o \
-	 swupdate_dict.o
+	 swupdate_dict.o \
+	 semver.o

=== corelib/Makefile ===
--- 
+++ 
@@ -5,16 +5,27 @@
 lib-$(CONFIG_DOWNLOAD)		+= downloader.o
 lib-$(CONFIG_MTD)		+= mtd-interface.o
 lib-$(CONFIG_LUA)		+= lua_interface.o lua_compat.o
-ifeq ($(CONFIG_SSL_IMPL_OPENSSL),y)
+ifeq ($(CONFIG_SSL_IMPL_OPENSSL)$(CONFIG_SSL_IMPL_WOLFSSL),y)
 lib-$(CONFIG_HASH_VERIFY)	+= verify_signature.o
+ifeq ($(CONFIG_PKCS11),y)
+lib-$(CONFIG_ENCRYPTED_IMAGES)	+= swupdate_decrypt_pkcs11.o
+else
 lib-$(CONFIG_ENCRYPTED_IMAGES)	+= swupdate_decrypt.o
+endif
 lib-$(CONFIG_SIGALG_RAWRSA)	+= swupdate_rsa_verify.o
 lib-$(CONFIG_SIGALG_RSAPSS)	+= swupdate_rsa_verify.o
+endif
+ifeq ($(CONFIG_SSL_IMPL_OPENSSL),y)
+# wolfSSL does not support CMS in the compatibility layer yet
 lib-$(CONFIG_SIGALG_CMS)	+= swupdate_cms_verify.o
 endif
 ifeq ($(CONFIG_SSL_IMPL_MBEDTLS),y)
 lib-$(CONFIG_HASH_VERIFY)	+= verify_signature_mbedtls.o
+ifeq ($(CONFIG_PKCS11),y)
+lib-$(CONFIG_ENCRYPTED_IMAGES)	+= swupdate_decrypt_pkcs11.o
+else
 lib-$(CONFIG_ENCRYPTED_IMAGES)	+= swupdate_decrypt_mbedtls.o
+endif
 lib-$(CONFIG_SIGALG_RAWRSA)	+= swupdate_rsa_verify_mbedtls.o
 lib-$(CONFIG_SIGALG_RSAPSS)	+= swupdate_rsa_verify_mbedtls.o
 endif

=== doc/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/SWSpecifications.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/SWSpecifications.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/SWSpecifications"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/SWSpecifications"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	make -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== handlers/Makefile ===
--- 
+++ 
@@ -12,6 +12,7 @@
 obj-$(CONFIG_BOOTLOADERHANDLER) += boot_handler.o
 obj-$(CONFIG_CFI)	+= flash_handler.o
 obj-$(CONFIG_DISKPART)	+= diskpart_handler.o
+obj-$(CONFIG_UNIQUEUUID)	+= uniqueuuid_handler.o
 obj-$(CONFIG_CFIHAMMING1)+= flash_hamming1_handler.o
 obj-$(CONFIG_LUASCRIPTHANDLER) += lua_scripthandler.o
 obj-$(CONFIG_RAW)	+= raw_handler.o

=== ipc/Makefile ===
# Copyright (C) 2014-2018 Stefano Babic <sbabic@denx.de>
#
# SPDX-License-Identifier:     GPL-2.0-or-later
obj-y			+= network_ipc.o network_ipc-if.o progress_ipc.o

EXTRA_CFLAGS += -fPIC

=== mongoose/Makefile ===
--- 
+++ 
@@ -7,7 +7,7 @@
 endif
 ifneq ($(CONFIG_MONGOOSESSL),)
 KBUILD_CFLAGS += -DMG_ENABLE_SSL=1
-ifeq ($(CONFIG_SSL_IMPL_OPENSSL),y)
+ifeq ($(CONFIG_SSL_IMPL_OPENSSL)$(CONFIG_SSL_IMPL_WOLFSSL),y)
 KBUILD_CFLAGS += -DMG_SSL_IF=MG_SSL_IF_OPENSSL
 endif
 ifeq ($(CONFIG_SSL_IMPL_MBEDTLS),y)

=== parser/Makefile ===
# Copyright (C) 2014-2018 Stefano Babic <sbabic@denx.de>
#
# SPDX-License-Identifier:     GPL-2.0-or-later
lib-y				+= parser.o parse_external.o

=== suricatta/Makefile ===
# Copyright (C) 2014-2018 Stefano Babic <sbabic@denx.de>
#
# SPDX-License-Identifier:     GPL-2.0-or-later
lib-$(CONFIG_SURICATTA) += suricatta.o common.o
ifneq ($(CONFIG_SURICATTA_HAWKBIT),)
lib-$(CONFIG_SURICATTA) += server_hawkbit.o
endif
lib-$(CONFIG_SURICATTA_GENERAL) += server_general.o

=== test/Makefile ===
--- 
+++ 
@@ -15,7 +15,9 @@
 ## along with this program; if not, write to the Free Software
 ## Foundation, Inc.
 
+ifneq ($(CONFIG_PKCS11),y)
 tests-$(CONFIG_ENCRYPTED_IMAGES) += test_crypt
+endif
 tests-$(CONFIG_HASH_VERIFY) += test_hash
 ifeq ($(CONFIG_SIGALG_RAWRSA),y)
 tests-$(CONFIG_SIGNED_IMAGES) += test_verify
@@ -47,7 +49,7 @@
 						"$(SWLIBS)" \
 						"$(LDLIBS) cmocka"
 
-EXECUTE_TEST = echo "RUN $(subst $(obj)/,,$(var))"; CMOCKA_MESSAGE_OUTPUT=TAP $(var)
+EXECUTE_TEST = echo "RUN $(subst $(obj)/,,$(var))"; LD_LIBRARY_PATH=$(objtree) CMOCKA_MESSAGE_OUTPUT=TAP $(var)
 
 PHONY += default
 default:

=== debian/changelog ===
swupdate (2020.11-2+deb11u1) bullseye; urgency=medium

  * Add swupdate system user
  * Create the sockets for group use with SocketMode 0660

 -- Bastian Germann <bage@debian.org>  Mon, 27 Nov 2023 11:10:38 +0100

swupdate (2020.11-2) unstable; urgency=medium

  [ Bastian Germann ]
  * d/clean:
    - Clean leftover files via dh_clean (Closes: #979806)
  [ SZ Lin (林上智) ]
  * d/control:
    - Bump Standards-Version to 4.5.1

 -- SZ Lin (林上智) <szlin@debian.org>  Tue, 19 Jan 2021 15:56:14 +0800

swupdate (2020.11-1) unstable; urgency=medium

  [ Bastian Germann ]
  * Fix test failed issues on mipsel and mips64el platforms (Closes: #972691)
  * Drop upstream patch
  * Add a pkcs11 profile
  * Mark library packages Multi-Arch: same
  * Move swupdate-dev to libswupdate-dev
  * Add libswupdate0.1 package
  * Add 2020.11 copyright info
  * Remove unused build dependency
  * New upstream version 2020.11 (Closes: #976055)
  * Set CROSS_COMPILE default
  * Rename config option
  * Add grub profile and fall back to in memory state
  * d/copyright: Remove outdated link
  * d/copyright: Remove unclear OpenSSL exception
  * Trigger swupdate on usb media only
  * Disable remote handler

 -- SZ Lin (林上智) <szlin@debian.org>  Mon, 28 Dec 2020 17:07:42 +0800

=== debian/control ===
--- 
+++ 
@@ -5,8 +5,8 @@
 Uploaders: SZ Lin (林上智) <szlin@debian.org>,
            Nobuhiro Iwamatsu <iwamatsu@debian.org>
 Build-Depends: debhelper-compat (= 13),
-               dh-exec,
                dh-lua <!nolua>,
+               dh-sysuser,
                liblua5.2-dev <!nolua>,
                libfdisk-dev,
                latexmk <!nodoc>,
@@ -17,9 +17,10 @@
                librsync-dev,
                libssl-dev,
                libsystemd-dev,
-               libzmq3-dev,
                zlib1g-dev,
                libzstd-dev,
+               libp11-kit-dev <pkg.swupdate.p11>,
+               libwolfssl-dev <pkg.swupdate.p11>,
                libmtd-dev <!pkg.swupdate.bpo>,
                libubi-dev <!pkg.swupdate.bpo>,
                libwebsockets-dev (>= 3.2.0) <!pkg.swupdate.bpo>,
@@ -32,7 +33,7 @@
                texlive-latex-recommended <!nodoc>,
                texlive-fonts-recommended <!nodoc>,
                texlive-formats-extra <!nodoc>
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Homepage: https://sbabic.github.io/swupdate
 Vcs-Browser: https://salsa.debian.org/debian/swupdate
@@ -58,13 +59,39 @@
   - Allow custom handlers for installing FPGA/ microcontroller firmware.
   - Power-Off safe
 
-Package: swupdate-dev
+Package: libswupdate-dev
 Section: libdevel
-Architecture: linux-any
-Depends: ${misc:Depends}
+Architecture: any
+Multi-Arch: same
+Depends: ${misc:Depends}, libswupdate0.1 (= ${binary:Version})
 Suggests: swupdate-doc
+Breaks: swupdate-dev (<< 2020.11-1)
+Replaces: swupdate-dev (<< 2020.11-1)
 Description: Development files for swupdate framework
- This package contains the development files for swupdate.
+ This package contains the development files for libswupdate.
+ .
+ swupdate is a Linux update agent with the goal to provide an efficient and
+ safe way to update an embedded system.
+ .
+  - Install on embedded media (eMMC, SD, Raw NAND, NOR and SPI-NOR flashes)
+  - Allow delivery single image for multiple devices
+  - Multiple interfaces for getting software
+    1. local storage
+    2. integrated web server
+    3. integrated REST client connector to hawkBit
+    4. remote server download
+  - Software delivered as images, gzipped tarball, etc
+  - Allow custom handlers for installing FPGA/ microcontroller firmware.
+  - Power-Off safe
+
+Package: libswupdate0.1
+Section: libs
+Architecture: any
+Multi-Arch: same
+Depends: ${misc:Depends}, ${shlibs:Depends}
+Description: Library for controlling the swupdate framework
+ This package contains the library libswupdate which is used to control
+ swupdate.
  .
  swupdate is a Linux update agent with the goal to provide an efficient and
  safe way to update an embedded system.
@@ -105,6 +132,7 @@
 Package: lua-swupdate
 Section: interpreters
 Architecture: linux-any
+Multi-Arch: same
 Build-Profiles: <!nolua>
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: swupdate bindings for the Lua language

=== debian/rules ===
--- 
+++ 
@@ -1,16 +1,20 @@
 #!/usr/bin/make -f
+include /usr/share/dpkg/architecture.mk
+
+ifneq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
+export CROSS_COMPILE ?= $(DEB_HOST_GNU_TYPE)-
+endif
+
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
+export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic -I/usr/include/p11-kit-1
+export LIBDIR=usr/lib/${DEB_HOST_MULTIARCH}
 export HAVE_LUA=n
 ifeq (,$(filter nolua,$(DEB_BUILD_PROFILES)))
 export LUA_VERSION=5.2
 export LUA_MODNAME=lua_swupdate
 export PKG_NAME=swupdate
-export DH_WITH=--with lua
+export DH_WITH=,lua
 export HAVE_LUA=y
-endif
-ifneq (,$(findstring mips,$(DEB_HOST_ARCH)))
-export DEB_BUILD_MAINT_OPTIONS:=$(DEB_BUILD_MAINT_OPTIONS) nocheck
 endif
 
 override_dh_auto_configure:
@@ -24,11 +28,16 @@
 else
 	echo "# CONFIG_MTD is not set"     >> configs/debian_defconfig
 endif
-ifeq (,$(filter pkg.swupdate.uboot,$(DEB_BUILD_PROFILES)))
+ifneq (,$(filter pkg.swupdate.uboot,$(DEB_BUILD_PROFILES)))
+	echo CONFIG_UBOOT=y                             >> configs/debian_defconfig
+else ifneq (,$(filter pkg.swupdate.grub,$(DEB_BUILD_PROFILES)))
 	echo CONFIG_BOOTLOADER_GRUB=y                   >> configs/debian_defconfig
 	echo CONFIG_GRUBENV_PATH=\"/boot/grub/grubenv\" >> configs/debian_defconfig
 else
-	echo CONFIG_UBOOT=y                             >> configs/debian_defconfig
+	echo CONFIG_BOOTLOADER_NONE=y                   >> configs/debian_defconfig
+endif
+ifneq (,$(filter pkg.swupdate.p11,$(DEB_BUILD_PROFILES)))
+	echo CONFIG_PKCS11=y >> configs/debian_defconfig
 endif
 ifneq (,$(LUA_VERSION))
 	echo CONFIG_LUAPKG=\"lua$(LUA_VERSION)\" >> configs/debian_defconfig
@@ -52,7 +61,11 @@
 	dh_auto_build -- V=1
 
 override_dh_auto_test:
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
+ifeq (,$(findstring mips,$(DEB_HOST_ARCH)))
 	dh_auto_test -- V=1
+endif
+endif
 
 override_dh_auto_install:
 	dh_auto_install -- V=1
@@ -73,9 +86,5 @@
 override_dh_missing:
 	dh_missing --fail-missing
 
-ifneq (,$(filter nocheck,$(DEB_BUILD_PROFILES)))
-override_dh_auto_test:
-endif
-
 %:
-	dh $@ $(DH_WITH)
+	dh $@ --with sysuser$(DH_WITH)

=== debian/tests/control ===
Tests: testsuite
Depends: @, build-essential, pkg-config, cpio, openssl, wget, ca-certificates
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts=mode=git,pgpmode=gittag \
  https://github.com/sbabic/swupdate.git refs/tags/([\d\.]+)
